Option Compare Binary
Option Explicit On 
Option Strict On

Imports RemoteLoader
Imports System
Imports System.Reflection

Public Module Program
    Public Sub Main()

        ' Create appdomain.
        Dim Domain As AppDomain = AppDomain.CreateDomain("Blabbel")

        ' Load remote loader into secondary appdomain.
        Dim Factory As RemoteLoaderFactory = _
            DirectCast( _
                Domain.CreateInstanceAndUnwrap( _
                    "RemoteLoader", _
                    "RemoteLoader.RemoteLoaderFactory" _
                ), _
                RemoteLoaderFactory _
            )

        ' Instantiate object in the secondary appdomain without loading it
        ' into the application's appdomain.
        Dim Obj As Object = _
            Factory.Create( _
                "ClassLibrary1.dll", _
                "ClassLibrary1.Class1", _
                Nothing _
            )

        ' Invoke the method through the remote interface.
        Dim Remote As IRemoteInterface = _
            DirectCast(Obj, IRemoteInterface)
        Remote.Invoke("DoSomething", Nothing)
        Remote = Nothing

        ' Unload secondary appdomain.
        AppDomain.Unload(Domain)
        Domain = Nothing

        ' ...

#If DEBUG Then
        Console.Read()
#End If
    End Sub
End Module